/* Principiile Programarii Orientate pe Obiecte (POO)
    1. Abstractizare
    2. Incapsulare si Protectia Datelor
    3. Mostenire
    4. Polimorfism
*/

#include <iostream>
#include <string>

class Student {
public:
    // Constructor
    Student()
    {
        name = "";
        age = 0;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    Student(std::string _name, int _age )
    {
        name = _name;
        age = _age;
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
    // Destructor
    ~Student()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
private:
    std::string name;
    int age;
};

int main()
{

    return 0;
}
