/* Principiile Programarii Orientate pe Obiecte (POO)
    1. Abstractizare
    2. Incapsulare si Protectia Datelor
    3. Mostenire
    4. Polimorfism
*/

#include <iostream>

class Student {
public:
    // Constructor
    Student()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }

    // Destructor
    ~Student()
    {
        std::cout << __PRETTY_FUNCTION__ << '\n';
    }
private:
    std::string name;
    int age;
};

int main()
{
    std::cout << "Prima instructiune\n";
    {
        Student s1;
    }

    std::cout << "Ultima instructiune\n";
    return 0;
}
